//---------------------------------------------------------------------------------//

				//CLASSE CALCULATRICE.HH//

//---------------------------------------------------------------------------------//

#ifndef CALCULATRICE_HH
#define CALCULATRICE_HH

//Inclusion des librairie
#include <libglademm.h>
#include <iostream>
#include <gtkmm.h>
#include <cassert>
#include <stack>
#include <stdlib.h>
#include <boost/algorithm/string.hpp>
#include <boost/lexical_cast.hpp>
#include <boost/tokenizer.hpp>
#include <gtk/gtk.h>

//inclusion des classes du projet
#include "Nombre.hh"
#include "Moteur.hh"
#include "About.hh"

//Définition de la classe
class Calculatrice : public Gtk::Dialog{

	//attributs privés
	private:
		
		Glib::RefPtr<Gnome::Glade::Xml> xml;

		Moteur Calcul;

		Gtk::Dialog* fenetre;
		Gtk::Label* ecran;
		Gtk::Entry* entree;

		Gtk::Button* m_about;

		Gtk::Button* m_quitter;
		Gtk::Button* m_enter;
		Gtk::Button* m_egal;
		Gtk::Button* m_clear;
		Gtk::Button* m_esc;
		Gtk::Button* m_drop;
		Gtk::Button* m_swap;
		Gtk::Button* m_roll;
		Gtk::Button* m_undo;
		Gtk::Button* m_redo;

		Gtk::Button* m_plus;
		Gtk::Button* m_minus;
        	Gtk::Button* m_mult;
        	Gtk::Button* m_div;

		Gtk::Button* m_carre;
		Gtk::Button* m_racine;
		Gtk::Button* m_puiss;
		Gtk::Button* m_exp;
		Gtk::Button* m_log;
		Gtk::Button* m_inv;
		
		Gtk::Button* m_chs;

		Gtk::Button* m_sin;
		Gtk::Button* m_cos;
		Gtk::Button* m_tan;
		Gtk::Button* m_asin;
		Gtk::Button* m_acos;
		Gtk::Button* m_atan;
		
		Gtk::Button* m_guillemet_droit;
		Gtk::Button* m_guillemet_gauche;
		Gtk::Button* m_eval;
		Gtk::Button* m_espace;
		Gtk::Button* m_plot;
		Gtk::Button* m_slot;
		Gtk::Button* m_sep;	

		Gtk::Button* nb0;
		Gtk::Button* nb1;
		Gtk::Button* nb2;
		Gtk::Button* nb3;
		Gtk::Button* nb4;
		Gtk::Button* nb5;
		Gtk::Button* nb6;
		Gtk::Button* nb7;
		Gtk::Button* nb8;
		Gtk::Button* nb9;
		Gtk::Button* Pi;

		Gtk::Button* a;
		Gtk::Button* b;	
		Gtk::Button* c;
		Gtk::Button* d;	
		Gtk::Button* e;	
		Gtk::Button* f;	
		Gtk::Button* g;	
		Gtk::Button* h;	
		Gtk::Button* i;	
		Gtk::Button* j;	
		Gtk::Button* k;	
		Gtk::Button* l;	
		Gtk::Button* m;	
		Gtk::Button* n;	
		Gtk::Button* o;	
		Gtk::Button* p;	
		Gtk::Button* q;	
		Gtk::Button* r;	
		Gtk::Button* s;	
		Gtk::Button* t;	
		Gtk::Button* u;	
		Gtk::Button* v;	
		Gtk::Button* w;
		Gtk::Button* x;	
		Gtk::Button* y;	
		Gtk::Button* z;
	
	//Méthodes publiques
	public :

		Calculatrice();
		Gtk::Dialog& getCalculatrice();

		void init_nb();
		void init_carac();
		void init_math();
		void init_action();

		void close();
		void saisie();
		void resultat();
		void clear();

		void effacer_saisie();

		void rafraichissement(std::string nom);
		void rafraichissement();

		void on_drop();
		void on_swap();
		void on_roll();
		void on_undo();
		void on_redo();

		void on_about();
	
		void on_button_plus();
        	void on_button_minus();
        	void on_button_mult();
        	void on_button_div();

		void on_carre();
		void on_racine();
		void on_puiss();
		void on_exp();
		void on_log();
		void on_inv();

		void on_chs();		

		void on_sin();
		void on_cos();
		void on_tan();
		void on_asin();
		void on_acos();
		void on_atan();

		void on_guillemet_droit();
		void on_guillemet_gauche();
		void on_espace();
		void on_eval();
		void on_plot();
		void on_slot();
		void on_sep();		

		void on_nb0();
		void on_nb1();
		void on_nb2();
		void on_nb3();
		void on_nb4();
		void on_nb5();
		void on_nb6();
		void on_nb7();
		void on_nb8();
		void on_nb9();
		void on_Pi();

		void on_a();
		void on_b();
		void on_c();
		void on_d();
		void on_e();
		void on_f();
		void on_g();
		void on_h();
		void on_i();
		void on_j();
		void on_k();
		void on_l();
		void on_m();
		void on_n();
		void on_o();
		void on_p();
		void on_q();
		void on_r();
		void on_s();
		void on_t();
		void on_u();
		void on_v();
		void on_w();
		void on_x();
		void on_y();
		void on_z();		
};
#endif
