//-------------------------- Classe Nombre ----------------------//

//---------------------------------------------------------------//
//Classe utilisé par la pile pour réaliser les différentes
//opérations et fonctions. Elle renvoit donc les données du
//modèle mathématique utilisé par le moteur.
//--------------------------------------------------------------//
#ifndef NOMBRE_HH
#define NOMBRE_HH

#include "Donnee.hh"
#include <math.h>

class Nombre : public Donnee {
	
	public :
		Nombre();
		Nombre(float x):Donnee(x){}
		Nombre(const Nombre& a):Donnee(a.nb){}
		~Nombre();
		float getFloat();
		void setNombre(float x);

		Nombre addition(Nombre x);
		Nombre soustraction(Nombre x);
		Nombre multiplication(Nombre x);
		Nombre division(Nombre x);

		Nombre carre();
		Nombre racine();
		Nombre expo();
		Nombre logarithme();
		Nombre puiss(float x);
		Nombre inverse();

		Nombre chn_signe();

		Nombre sinus();
		Nombre cosinus();
		Nombre tangente();
		Nombre asinus();
		Nombre acosinus();
		Nombre atangente();
	
};

#endif
