# -*- coding: utf-8 -*-
#
# Client to share and get files via XMPP
# Copyright (C) 2010 Sébastien Dumont
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Import from the Standard Library
from re import compile as recompile

# Import from here
from shell import ShellCommand, CommandError


# TODO cd ls help get pwd quit

# FIXME EXAMPLE_LIST is used for simulation
EXAMPLE_LIST = ['toto.py', 'toto.mkv', 'toto.flac']



class ListCommand(ShellCommand):
    """ [regexp] : list files of the current directory.
    """

    MIN_ARG = 0
    MAX_ARG = 1

    def process(self, args):
        ShellCommand.process(self, args)
        # FIXME we must fetch list on real server
        files_list = EXAMPLE_LIST[:]
        regexp = None
        if args:
            try:
                regexp = recompile(args[0])
            except Exception:
                raise CommandError

        for f in files_list:
            if not regexp or regexp.match(f):
                print(f)



# Commands mapping
COMMANDS = {'ls': ListCommand()}

