# -*- coding: utf-8 -*-
# Copyright (C) 2010 Romain Gauthier <romain.gauthier@masteri2l.org>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Import from the standard library
from imp import load_module, PKG_DIRECTORY
from os import getcwd
from os.path import join, dirname
from unittest import TestCase, main

# Import from here
load_module('clientedl', None, getcwd(), ('', '', PKG_DIRECTORY))
current_dir = dirname(__file__)
from clientedl.xmpp import get_template


class TestXMPPTemplates(TestCase):


    def test_inheritance(self):
        msg_uri = 'file_listing/publication/new_file_listing/create.xml'
        template = get_template(msg_uri)
        namespace = {'request_type': 'set',
                     'sender': 'juliet@capulet.com/balcony',
                     'receiver': 'pubsub.shakespeare.lit',
                     'action_id': 'create3',
                     'repo_name': 'juliets_sonnets'}
        expected_file_uri = join(current_dir, 'test_msg', msg_uri)
        expected = open(expected_file_uri).read()
        rendered = template.render_unicode(**namespace)
        self.assertEqual(rendered.split(), expected.split())



if __name__ == '__main__':
    main()

