# -*- coding: utf-8 -*-
# Copyright (C) 2010 Romain Gauthier <romain.gauthier@masteri2l.org>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Import from here
from clientedl.xmpp.utils import get_template


class Action(object)

    templates_dir = None

    def _get_template(self, template_name):
        return get_template(join(templates_dir, template_name))



class Addition(Action):

    def __init__(self):
        raise NotImplementedError



class Modification(Action):

    def __init__(self):
        raise NotImplementedError



class Publication(Action):

    templates_dir = 'filelisting/publication'

    def add_subsection(self):
        template_name = 'add_subsection/create.xml'
        template_create = self._get_template(template_name)
        template_name = 'add_subsection/config.xml'
        template_config = self._get_template(template_name)


    def new_file_listing(self):
        template_name = 'new_file_listing/create.xml'
        template_create = self._get_template(template_name)
        template_name = 'new_file_listing/config.xml'
        template_config = self._get_template(template_name)



class Revisions(Action):

    def __init__(self):
        raise NotImplementedError



class Subscription(Action):

    def __init__(self):
        raise NotImplementedError

