#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# Copyright (C) 2010 Romain Gauthier <romain.gauthier@masteri2l.org>
# Copyright (C) 2010 Sergiu Mihai <sergiu.mihai@devlibre.net>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Import from twisted
from twisted.words.protocols.jabber.jid import JID

# Import from here
from utils import get_template


class XMPPSession(object):
    """ A xmpp session. A proxy object which handle the xmpp connexion.
    """

    def __init__(self, id, password, host=None, port=5222, **kwargs):
        self.jid = JID(id)
        self.password = password
        self.host = host or self.jid.host
        self.port = port
        for key, value in kwargs.iteritems():
            setattr(self, key, value)

