#!/usr/bin/python

class grid:
    """ class model du mvc : contient les donnees de la grille
    implemente le comportement d'une liste pour se substituer
    a la liste originale "grid" """
    def __init__(self, size):
        self.size = size

        self.data = range(self.size * self.size)
        for y in range(self.size):
            for x in range(self.size):
                if (x % 2 == 1 and y % 2 == 1) or (x % 2 == 0 and y % 2 == 0):
                    self.data[x + y * self.size] = -1
                else:
                    self.data[x + y * self.size] = 1

        self.colnum = {"green": -2, "red": 2}

    def __getitem__(self, key):
        return self.data[key]

    def __setitem__(self, key, value):
        self.data[key] = value

    def verifie(self):
        r = 0
        g = 0
        y = 0
        while y < self.size:
            x = 0
            while x < self.size:
                v = self.data[x+y*self.size]
                if (v < 0):
                    g+=1
                else:
                    r+=1
                x = x + 1
            y = y + 1
        if r > 19 or g > 19:
            print "il y a un tricheur !!!!!!!!!!!!!!"

    def finish(self,value):
        ok = True
        y = 0
        while y < self.size and ok:
            x = 0
            while x < self.size and ok:
                v = self.data[x+y*self.size]
                if v == value:
                    ok = False
                x = x + 1
            y = y + 1
        return ok

    def normColorToInt(self, color):
        """ normalise une valeur de couleur (2, -2, "green", "red", "green" ...)
        retourne la valeur numerique """
        if isinstance(color, int):
            assert color == -2 or color == 2
            return color

        assert color.lower() == "green" or color.lower() == "red"
        return self.colnum[color.lower()]

    def normColorToStr(self, color):
        """ normalise une valeur de couleur en Chaine
        retourne "green" ou "red" """
        c = self.normColorToInt(color)
        if c == -2:
            return "green"
        else:
            return "red"

    def push(self, move, player):
        # normalisation des parametres pour plus de flexibilite
        number = int(move["number"])
        position = move["position"].lower()
        color = self.normColorToInt(move["color"])
        player = self.normColorToInt(player)

        if position == 'left':
            return self.push_left(number, color, player)
        if position == 'right':
            return self.push_right(number, color, player)
        if position == 'top':
            return self.push_top(number, color, player)
        if position == 'bottom':
            return self.push_bottom(number, color, player)

    def push_left(self, number, color, player):
        if self.data[self.size-1+number*self.size] != -player:
            out = self.data[self.size-1+number*self.size]
            j = self.size-1
            while j >= 1:
                self.data[j+number*self.size] = self.data[j-1+number*self.size]
                j = j - 1
            self.data[number*self.size] = color
            return out
        else:
            return 0

    def push_right(self, number, color, player):
        if self.data[number*self.size] != -player:
            out = self.data[number*self.size]
            j = 0
            while j < self.size-1:
                self.data[j+number*self.size] = self.data[j+1+number*self.size]
                j = j + 1
            self.data[number*self.size+self.size-1] = color
            return out
        else:
            return 0

    def push_bottom(self, number, color, player):
        if self.data[number] != -player:
            out = self.data[number]
            j = 0
            while j < self.size-1:
                self.data[number+j*self.size] = self.data[number+(j+1)*self.size]
                j = j + 1
            self.data[number+self.size*(self.size-1)] = color
            return out
        else:
            return 0

    def push_top(self, number, color, player):
        if self.data[number+(self.size-1)*self.size] != -player:
            out = self.data[number+(self.size-1)*self.size]
            j = self.size-1
            while j >= 1:
                self.data[number+j*self.size] = self.data[number+(j-1)*self.size]
                j = j - 1
            self.data[number] = color
            return out
        else:
            return 0
