/*----------------------------------------------------------------------*/
/* Fichier : tpi2ldd1wait.c						*/
/* Auteur  : D. Duvivier - LIL/ULCO					*/
/* Date    : 16/09/09							*/
/* Objectif: TP N3 M2/I2L Systme Rseaux Scurit			*/
/*	     Test des primitives "fork()", "wait()" et "execl()"	*/
/*----------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <sys/types.h>

pid_t pid; /* Variable partagee : process identifier du fils ou 0 */

int main(void) {
  puts("Lancement du programme...");
  pid = fork();
  if (pid < 0) {
    perror("echec fork");
    exit(EXIT_FAILURE); /* fork() a echoue -> fin du programme */
  }
  else if (pid > 0) {
    /* Variable uniquement accedee par le pere */
    int status; /* Code de retour du processus fils */
    /* Code du pere */
    puts("Le processus pre attend le fils...");
    wait(&status);
    puts("Fin d'attente du pere...");
    printf("Le code de retour du fils est %d\n", status);
  }
  else {
    /* Code du fils */
    puts("Le fils lance ls...");
    execl("/bin/ls", (char *)NULL);
  }
  /* Qui va passer ici en fin de programme sauf erreur ? */
  printf("Fin du processus %d\n", getpid());
  return(EXIT_SUCCESS);
}
