/*----------------------------------------------------------------------*/
/* Fichier : tpi2ldd1fork.c						*/
/* Auteur  : D. Duvivier - LIL/ULCO					*/
/* Date    : 16/09/09							*/
/* Objectif: TP N3 M2/I2L Systme Rseaux Scurit			*/
/*	     Test de la primitive "fork()"				*/
/*----------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <sys/types.h>

pid_t pid; /* Variable partagee : process identifier du fils ou 0 */

int main(void) {
  puts("Lancement du programme...");
  printf("Le pid du processus est %d et son ppid est %d\n", getpid(), getppid());
  pid = fork();
  if (pid < 0) {
    perror("echec fork");
    exit(EXIT_FAILURE); /* fork() a echoue -> fin du programme */
  }
  else if (pid > 0) {
    /* Code du pre */
    puts("Code du pre...");
    printf("Le pid du fils est %d et son ppid est %d\n", pid, getppid());
    puts("Le pre se met en attente pour 10 secondes ...");
    sleep(10);
    puts("Fin d'attente du pere...");
  }
  else {
    /* Code du fils */
    puts("Code du fils...");
    puts("Le fils se met en attente pour 5 secondes ...");
    sleep(5);
    puts("Fin d'attente du fils...");
  }
  /* Le pre et le fils vont passer ici en fin de programme sauf erreur */
  printf("Fin du processus %d\n", getpid());
  return(EXIT_SUCCESS);
}
