/*----------------------------------------------------------------------*/
/* Fichier : tp1.c							*/
/* Auteur  : D. Duvivier - LIL/ULCO					*/
/* Date    : 16/09/09							*/
/* Objectif: TP N3 M2/I2L Systme Rseaux Scurit			*/
/*	     Test des signaux et de la primitive "fork()"		*/
/*----------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <math.h>
#include <signal.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <sys/types.h>

int pid;

/* Gestion des signaux */
void signal_handler(int signal) {
  switch(signal) {
  case SIGHUP: /* SIGHUP = 1 */
    /* Classiquement on force la relecture de la configuration */
    puts("Signal SIGHUP intercept par notre handler");
  break;
  case SIGTERM: /* SIGTERM = 15 */
    /* Classiquement on libre les ressources et on quitte */
    puts("Signal SIGTERM intercept par notre handler");
    exit(99);
  break;
  }
}

/* La fonction suivante (commente) peut servir  calculer des dlais
   de dure alatoire...
float floatrand (float min, float max) {
  return ((float)rand() / RAND_MAX * (max-min)) + min;
}
*/

int main(void) {
  puts("Lancement du programme...");
  srand(time(NULL));

  signal(SIGHUP, signal_handler);
  signal(SIGTERM, signal_handler);
  
  pid = fork();
  if (pid < 0) {
    perror("echec fork");
    exit(EXIT_FAILURE);
  }
  else if (pid > 0) {
    /* Code du pre */
    puts("Code du pre...");
    printf("Le pid du fils est %d\n", pid);
    puts("Le pre se met en attente...");
    sleep(60);
    puts("Fin d'attente du pere...");
  }
  else {
    /* Code du fils */
    puts("Code du fils...");
    if (chdir("/tmp") < 0) {
      /* Ces deux lignes sont redontantes (une seule suffit au choix) */
      fprintf(stderr, "L'erreur '%s' s'est produite\n",
              strerror(errno));
      perror("echec chdir /tmp");
      exit(EXIT_FAILURE);
    }
    puts("Le fils se met en attente...");
    sleep(60);
    puts("Fin d'attente du fils...");
  }
  /* Le pre et le fils vont passer ici en fin de programme sauf erreur */

  return(EXIT_SUCCESS);
}
