/*----------------------------------------------------------------------*/
/* Fichier : tstlecteursredacteurs.c					*/
/* Auteur  : D. Duvivier - LIL/ULCO					*/
/* Date    : 21/02/08							*/
/* Objectif: TP/TD N1 L2/Info Systmes d'Exploitation			*/
/*	     Test d'une synchronisation entre processus			*/
/*	     -> modle "lecteurs / redacteurs"				*/
/*----------------------------------------------------------------------*/
/*
#############################################################################
#This program is free software; you can redistribute it and/or modify       #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 2 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program; if not, write to the Free Software               #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA #
#############################################################################
 */
#include <ddtools.h>

/* Ci-dessous on utilise un troisime smaphore en guise de variable */
/* partage entre plusieurs processus pour viter les complications */
#define mutex		semaphore0
#define protege_lecteur	semaphore1
#define lecteur		semaphore2

/* Nombre de lecteurs et de rdacteurs, doivent tre > 0  */
/* S.V.P. ne dpassez pas 32000 processus au total :-)) ! */
#define NBLECTEURS	10
#define NBREDACTEURS	5

/* Nombre de lectures et de rdactions de chaque processus, */
/* ces valeurs doivent tre > 0  */
#define NBLECTURES	10
#define NBREDACTIONS	10

/* Variables globales -> a viter/limiter normalement (!) */
/* -> ICI AUCUNE !!! */

/************************************************************************/
/* CODE D'INITIALISATION SPECIFIQUE A UN EXERCICE PARTICULIER :		*/
/* A APPELER AVANT LE/LES APPEL(s) A FORK :				*/
/************************************************************************/
void CodeDInitialisation(int argc, char *argv[]) {
  DD_init(argc, argv, 3); /* Initialisation pour 3 smaphores AVANT LE FORK !!! */
  DD_sem_setvalue(mutex, 1); /* Initialise smaphore mutex  1 */
  DD_sem_setvalue(protege_lecteur, 1); /* Initialise protege_lecteur  1 */
  DD_sem_setvalue(lecteur, 0); /* Initialise lecteur  0 */
}

/************************************************************************/
/* CODE D'UN REDACTEUR.							*/
/*----------------------------------------------------------------------*/
/* "Numero" est un numro de redacteur permettant de les distinguer     */
/************************************************************************/
void CodeDuRedacteur(int Numero) {

}

/************************************************************************/
/* CODE D'UN LECTEUR							*/
/*----------------------------------------------------------------------*/
/* "Numero" est un numro de lecteur permettant de les distinguer       */
/************************************************************************/
void CodeDuLecteur(int Numero) {

}

/************************************************************************/
/* CODE DU PERE								*/
/*----------------------------------------------------------------------*/
/* De manire  tre le plus "gnrique" possible, le code du pre va	*/
/* simplement consister  lancer les rdacteurs puis les lecteurs.	*/
/* Ce processus se bloquera ensuite en attente de la fin de tous les	*/
/* processus fils (lecteurs et redacteurs) via un appel  la procdure  */
/* DD_waitallchilds().							*/
/************************************************************************/
void CodeDuPere(void) {
    exit(EXIT_SUCCESS);
}

/************************************************************************/
/************************************************************************/
/* PROGRAMME PRINCIPAL : LANCEMENT DES PROCESSUS PERE ET FILS)		*/
/*----------------------------------------------------------------------*/
/* Ce programme doit garantir que le processus pre soit le dernier	*/
/* processus actif (pour appeler DD_close().				*/
/************************************************************************/
/************************************************************************/
int main(int argc, char *argv[]) {
  DD_pidmsg2("PERE", "Lancement du programme...");
  /* Initialisation(s) avant fork() */
  CodeDInitialisation(argc, argv);
  /* Code du pre */
  CodeDuPere();
  DD_pidmsg2("PERE", "Bloqu en attente de la terminaison de ses fils...");
  /* Bloquer le processus pre tant qu'au moins un fils est actif : */
  DD_waitallchilds();
  DD_close(); /* Seul le pre (dernier process actif) doit appeler DD_close() */
  /* Le pre et les fils vont passer ici en fin de programme sauf erreur */
  /* ou appel  exit() explicite dans le code des processus */
  /* QUESTION SUBSIDIAIRE : */
  /* QUI (pre et/ou fils) VA EFFECTIVEMENT EXECUTER CETTE */
  /* PARTIE DU CODE EN FIN D'EXECUTION DE(S) PROCESSUS */
  DD_pidmsg2("PEREouFILS", "Fin du programme");
  DD_pidmsg3("PEREouFILS","le processus parent porte le numro (ppid=", getppid());
  return(EXIT_SUCCESS);
}
