/*----------------------------------------------------------------------*/
/* Fichier : tstfork.c							*/
/* Auteur  : D. Duvivier - LIL/ULCO					*/
/* Date    : 21/02/08							*/
/* Objectif: TP/TD N1 L2/Info Systmes d'Exploitation			*/
/*	     Test de la primitive "fork()"				*/
/*----------------------------------------------------------------------*/
/*
#############################################################################
#This program is free software; you can redistribute it and/or modify       #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 2 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program; if not, write to the Free Software               #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA #
#############################################################################
*/
#include <ddtools.h>

/* Variables globales -> a viter/limiter normalement (!) */
pid_t pid; /* Variable partagee : process identifier du fils ou 0 */

int main(void) {
  puts("Lancement du programme...");
  printf("Le pid du processus est %d et son ppid est %d\n", getpid(), getppid());
  pid = fork(); /* On clone le pre via fork */
  if (pid < 0) {
    perror("echec fork");
    exit(EXIT_FAILURE); /* fork() a echoue -> fin du programme */
  }
  else if (pid > 0) {
    /* Code du pre */
    int status; /* Dclaration locale pour obtenir le code de retour du fils */
    puts("Code du pre...");
    printf("Le pid du processus courant est %d et son ppid est %d\n", getpid(), getppid());
    printf("La variable pid vaut %d\n", pid);
    puts("Le pre se met en attente pour 2 secondes ...");
    sleep(2);
    puts("Le pre se bloque en attente de la terminaison de son fils...");
    wait(&status);
    /* Vrification de la bonne terminaison du fils */
    if WIFEXITED(status) {
      /* Le fils s'est termin normalement par exit ou return */
      puts("Le processus fils s'est bien termin.");
    }
    else {
      /* Le fils s'est termin anormalement par un signal ou une exception */
      puts("Le processus fils s'est mal termin.");
    }
    puts("Fin d'attente du pere...");
  }
  else {
    /* Code du fils */
    puts("Code du fils...");
    printf("Le pid du processus courant est %d et son ppid est %d\n", getpid(), getppid());
    printf("La variable pid vaut %d\n", pid);
    puts("Le fils se met en attente pour 5 secondes ...");
    sleep(5);
    puts("Fin d'attente du fils...");
  }
  /* Le pre et le fils vont passer ici en fin de programme sauf erreur */
  printf("Fin du processus %d\n", getpid());
  return(EXIT_SUCCESS);
}
